      PROGRAM ALPHAOP
      DIMENSION aji(100), e(100)
C     CALCULATION OF REAL AND IMAGINARY POTENTIALS FOR ALPHA -
C     NUCLEUS  SYSTEMS
C     PLEASE SEND YOUR COMMENTS TO  kailas@magnum.barc.ernet.in
C     MODIFIED ON 30.8.2002
C     REAL AND IMAGINARY POTENTIALS STARTING FROM VOLUME INTEGRAL
C     SYSTEMATICS, POTENTIAL AND SLOPE OF POTENTIAL AT RADIUS
C     CLOSE TO STRONG ABSORPTION RADIUS
C     REF. MAHAUX,NGO AND SATCHLER NUCL.,PHYS.A 446,1986,354
C     FOR DISPERSION CORRECTION
      OPEN(UNIT = 5, FILE = 'INPUT')
      OPEN(UNIT = 6, FILE = 'OUTPUT')
      pi = 4.*ATAN(1.)
C     READ MASS OF TARGET, Z OF TARGET, 1ST EXCITED STATE OF TARGET(IN MeV)
C     AND E LAB (IN MeV)
      READ(5, 99001)amass, az, ex, elab
99001 FORMAT(F5.0, F5.0, 2F10.3)
      WRITE(6, 99002)amass, az, ex, elab
99002 FORMAT('AMASS ', F5.1, 5X, 'AZ ', F5.1, 5X, 'EX ', F10.3, '(MeV)', 
     &       5X, 'ELAB', F10.3, '(MeV)')
      at13 = amass**(1./3.)
C     R2.4 SYSTEMATICS FOR REAL AND IMAGINARY PARTS OF POTENTIAL
C     AR, AI ARE THE DIFFUSENESS PARAMETER VALUES
      r24r = 1.35*at13 + 2.55
      r24i = 1.35*at13 + 2.14
      ar = 0.76
      ai = 0.60
C     EREF IS THE REFERENCE ENERGY FOR NORMALISATION IN MAKING DISPERSION
C     RELATION CALCULATION
      eref = 140.01
      erefc = 140.01*amass/(amass + 4.)
C     JREF IS THE VOLUME INTEGRAL AT THE REFERENCE ENERGY AND IS
C     CALCULATED USING THE EMPIRICAL RELATION GIVEN BELOW
      jref = (224. - 0.98*erefc/amass**0.184 + 2.57*az/at13)
     &       *(1. + (2.05/at13))
      jref = -jref
C     IMAGINARY PART SYSTEMATICS IS TAKEN FROM A.SHRIDAHAR ET AL.
C     PHYS. REV. C30,1760 (1984)
      ajii = 32.8*(1. + 7.1/at13)
C     CALCULATION OF REAL AND IMAGINARY POTENTIAL RADII BY FITTING
C     R 2.4 AND VOLUME INTEGRAL VALUES AT E = 90 MEV
      const = 4.*pi/4./amass/3.
      const1 = pi*ar
      const2 = pi*ai
      ec = 90.*amass/(amass + 4.)
C     BAR IS THE COULOMB BARRIER
      bar = 1.44*2.*az/1.5/(4.**(1./3.) + amass**(1./3.))
C     ALPHA AND BETA ARE THE ENERGY COEFFICIENTS FOR IMAGINARY PART
      alpha = 0.05
      beta = 0.309
      ebar = bar + ex
      jrref = (224. - 0.98*ec/amass**0.184 + 2.57*az/at13)
     &        *(1. + (2.05/at13))
      jiief = ajii*(1. - EXP( - (90.-ebar)*alpha))
      j = 0
      ror = 1.0
 100  rr = ror*at13
      vor = jrref/const/rr**3./(1 + (const1/rr)**2.)
      r24rc = rr + ar*LOG((vor - 2.4)/2.4)
      diff = r24rc - r24r
      j = j + 1
      IF(j.LE.200)THEN
         IF(ABS(diff).GT.0.05)THEN
            ror = ror + 0.005
            GOTO 100
         ENDIF
      ENDIF
      roi = 1.2
      j = 0
 200  ri = roi*at13
      voi = jiief/const/ri**3./(1. + (const2/ri)**2.)
      r24ic = ri + ai*LOG((voi - 2.4)/2.4)
      diff = r24ic - r24i
      j = j + 1
      IF(j.LE.200)THEN
         IF(ABS(diff).GT.0.05)THEN
            roi = roi + 0.005
            GOTO 200
         ENDIF
      ENDIF
      ecm = elab*amass/(amass + 4.)
      ed = -elab + ebar
      edd = elab - ebar - 3.
      IF(edd.LE.0)THEN
         ajie = ajii*0.055*EXP( - beta*ed)
      ELSE
         ajie = ajii*(1. - EXP( - (elab-ebar)*alpha))
      ENDIF
C     MATCHING OF TWO FORMS OF IMAGINARY POTENTIALS IS DONE
C     AT EBAR + 3 MEV.
      n = 0
      ee = ex
      emax = ebar + 3.
 300  n = n + 1
      e(n) = ee
      IF(e(n).LE.emax)THEN
         aji(n) = ajii*0.055*EXP( - beta*( - e(n) + ebar))
         ee = ee + 2.
         GOTO 300
      ELSE
 350     IF(e(n).LE.140.)THEN
            aji(n) = ajii*(1. - EXP( - (e(n)-ebar)*alpha))
            n = n + 1
            ee = ee + 4.
            e(n) = ee
            GOTO 350
         ELSE
            no = n
C           DO 189 I = 1,NO-1
C           WRITE(6,188) E(I), AJI(I)
C189        CONTINUE
C188        FORMAT ( 'E',F10.3,'AJI',F10.3)
C           ASSUME THE DISPERSION CORRECTION  TO VANISH AT EREF.
            dvef = 0.
            dverf = 0.
            DO j = 1, no - 3
               dj = e(j + 1) - e(j)
               an1 = (elab - e(j))*LOG(ABS((elab-e(j))/dj))
               an2 = (elab - e(j + 1))*LOG(ABS((elab-e(j+1))/dj))
               dve = ((aji(j+1) - aji(j))/dj)*(an1 - an2)/pi
               anr1 = (eref - e(j))*LOG(ABS((eref-e(j))/dj))
               anr2 = (eref - e(j + 1))*LOG(ABS((eref-e(j+1))/dj))
               dver = ((aji(j+1) - aji(j))/dj)*(anr1 - anr2)/pi
               dvef = dvef + dve
               dverf = dverf + dver
            ENDDO
            v0 = jref - dverf
            ajre = dvef + v0
            ror = rr/at13
            roi = ri/at13
            vor = ajre/const/rr**3./(1 + (const1/rr)**2.)
            voi = ajie/const/ri**3./(1. + (const2/ri)**2.)
            vor = -vor
            ajre = -ajre
            WRITE(6, 99003)
99003       FORMAT(2X, 'ELAB(MeV) ', 2X, 'REAL V.I.(MeV fm3) ', 2X, 
     &             'IMG V.I.(MeV  fm3)')
            WRITE(6, 99004)elab, ajre, ajie
99004       FORMAT(F10.1, 9X, F10.1, 9X, F10.2)
            WRITE(6, 99005)
99005       FORMAT(2X, 'ELAB(MeV) ', 2X, 'VOR(MeV)  ', 2X, 'ROR(FM)   ', 
     &             2X, 'AR(FM)   ', 'VOI(MeV)  ', 2X, 'ROI(FM)   ', 
     &             'AI(FM)    ')
            WRITE(6, 99006)elab, vor, ror, ar, voi, roi, ai
99006       FORMAT(F10.1, 2X, F10.3, 2X, F8.3, 2X, F8.3, 2X, F10.3, 2X, 
     &             F8.3, 2X, F8.3)
         ENDIF
      ENDIF
      END
